/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#ifndef __BLIT_H
#define __BLIT_H

// blitfx flags
#define	BLITFX_ARITHSTRETCH		0x01
#define	BLITFX_DITHER			0x02
#define	BLITFX_AVOIDTEARING		0x04
#define	BLITFX_VMEMROTATED		0x10
#define BLITFX_ONLYDIFF			0x20
#define BLITFX_QUALITYCOLOR		0x40

typedef struct blitfx
{
	int Flags;			// combination of blitfx flags
	int ScaleX;			// 16.16 fixed point scale factor (before swapxy)
	int ScaleY;			// 16.16 fixed point scale factor (before swapxy)
	int Brightness;
	int Contrast;
	int Saturation;
	int Direction;
} blitfx;

DLL void Blit_Init();
DLL void Blit_Done();

DLL void* BlitCreate(const video* DstFormat,
			         const video* SrcFormat, const blitfx* FX);

DLL void BlitAlign(void* Handle, rect* DstRect, rect* SrcRect);

DLL void BlitImage(void* Handle, const planes Dst, const planes Src, const planes SrcLast,
				   int DstPicth, int SrcPitch ); // video pitch can be overridden

DLL void BlitRelease(void* Handle);

#endif
