/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#ifndef __COMMON_H
#define __COMMON_H

#ifdef __cplusplus
extern "C" {
#endif

#include "portab.h"

#ifdef COMMON_EXPORTS
#define DLL DLLEXPORT
#else
#define DLL DLLIMPORT
#endif

#if _WIN32_WCE < 400
#ifdef DEBUG
extern DLL void Assert(const char* Exp, const char* File, int Line );
#define assert(x) if (!(x)) Assert(#x,__FILE__,__LINE__);
#else
#define assert(x)
#endif
#else
#include <assert.h>
#endif

#include "err.h"
#include "str.h"
#include "node.h"
#include "audio.h"
#include "video.h"
#include "timer.h"
#include "platform.h"
#include "blit.h"
#include "idct.h"
#include "tools.h"
#include "flow.h"
#include "stream.h"
#include "format.h"
#include "format_base.h"
#include "file.h"
#include "http.h"
#include "waveout.h"

#ifdef __cplusplus
}
#endif

#undef DLL

#endif
