/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#ifndef __DYNCODE_ARM_H
#define __DYNCODE_ARM_H

#ifdef ARM

#define DYNCODE

#define STACKFRAME	10

#define R0	0
#define R1	1
#define R2	2
#define R3	3
#define R4	4
#define R5	5
#define R6	6
#define R7	7
#define R8	8
#define R9	9
#define R10	10
#define R11	11
#define R12	12
#define SP	13
#define R14	14
#define PC	15
#define LR	14

#define EQ	0
#define	NE	1
#define CS	2
#define CC	3
#define MI	4
#define PL	5
#define VS	6
#define VC	7
#define HI	8
#define LS	9
#define GE	10
#define LT	11
#define GT	12
#define LE	13
#define AL	14

#define LSL	0
#define LSR 1
#define ASR	2
#define ROR 3

#define AND				0
#define EOR				1
#define SUB				2
#define RSB				3
#define ADD				4
#define ADC				5
#define SBC				6
#define RSC				7
#define TST				8
#define TEQ				9
#define CMP				10
#define CMN				11
#define ORR				12
#define MOV				13
#define BIC				14
#define MVN				15
#define MUL				16
#define MLA				17
#define QADD			18
#define QSUB			19
#define QDADD			20
#define QDSUB			21
#define LDR				22
#define STR				23
#define LDR_POST		24
#define STR_POST		25
#define LDR_PRE			26
#define STR_PRE			27
#define LDR_POSTSUB		28
#define STR_POSTSUB		29
#define LDR_PRESUB		30
#define STR_PRESUB		31
#define B				32
#define BL				33

extern bool_t DSP;

void C(int);
void S();
void Byte();
void Half();
void SByte();
void SHalf();

void IConst( reg Dest, int Const );
void IMul( reg Dest, reg Op1, int Mul );

void I3( int, reg Dest, reg Op1, reg Op2 );
void I3S( int, reg Dest, reg Op1, reg Op2, int ShiftType, int Shift );
void I4( int, reg Dest, reg Op1, reg Op2, reg Op3 );
void I2( int, reg Dest, reg Op1 );
void I2C( int, reg Dest, reg Op1, int Const );

void I1P( int, reg Dest, dyninst* Block, int Ofs );
void I0P( int, int Cond, dyninst* );

void Break();

void CodeBegin();
void CodeEnd();

#endif
#endif
