/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#ifndef __STR_H
#define __STR_H

#define LANG_ID			FOURCC('L','A','N','G')

#define LANG_EN			FOURCC('E','N','_','_')
#define LANG_DEFAULT	LANG_EN

extern DLL int StringLang;

DLL void String_Init();
DLL void String_Done();

typedef struct stringdef
{
	int Class;
	int Id;
	const tchar_t* String;

} stringdef;

#define STRINGDEF_END { -1 }

DLL const stringdef* StringEnum( int Class, int No );
DLL const tchar_t* String( int Class, int Id );
DLL const tchar_t* StringDef( int Class, int Id );

//----------------------------
// string registration

DLL bool_t StringAdd( int Lang,int Class,int No,const tchar_t* );
DLL bool_t StringAddMore( int Lang, stringdef* );

#endif

