/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#include "stdafx.h"

#if defined(_WIN32)

#include <windows.h>

typedef struct http
{
	stream VMT;

	tchar_t URL[MAXPATH];
	HANDLE Handle;
	int Length;
	int Pos;
	bool_t Silent;

} http;

static int EnumType( http* p, int No, datadef* Param )
{
	return NodeEnumType(&No,Param,NodeParams,StreamParams,NULL);
}

static int Get( http* p, int No, void* Data, int Size )
{
	int Result = ERR_INVALID_PARAM;
	switch (No)
	{
	case NODE_ID: GETVALUE(HTTP_ID,int); break;
	case STREAM_MIME: GETSTRING(T("http")); break;
	case STREAM_URL: GETSTRING(p->URL); break;
	case STREAM_SILENT: GETVALUE(p->Silent,bool_t); break;
	case STREAM_LENGTH: GETVALUECOND(p->Length,int,p->Length>=0); break;
	}
	return Result;
}

static int Open( http* p, const tchar_t* URL, bool_t ReOpen )
{
	return ERR_NONE;
}

static int Set( http* p, int No, const void* Data, int Size )
{
	int Result = ERR_INVALID_PARAM;
	switch (No)
	{
	case STREAM_SILENT: SETVALUE(p->Silent,bool_t,ERR_NONE); break;
	case STREAM_URL:
		Result = Open(p,(const tchar_t*)Data,0);
		break;
	}
	return Result;
}

static int Read(http* p,void* Data,int Size)
{
	return -1;
}

static int Seek(http* p,int Pos,int SeekMode)
{
	return ERR_NOT_SUPPORTED;
}

static int EnumDir(http* p,const tchar_t* URL,const tchar_t* Exts,bool_t ExtFilter,streamdir* Item)
{
	return ERR_END_OF_FILE;
}

static void* Create( http* p )
{
	http* i = (http*) Alloc(sizeof(http));
	*i = *p;
	return i;
}

static void Delete( http* p )
{
	Open(p,NULL,0);
	Free(p);
}

static http HTTP = 
{
	EnumType,
	Get,
	Set,
	Create,
	Delete,

	Read,
	Seek,
	EnumDir,
};

void HTTP_Init()
{
	//NodeRegister((node*)&HTTP,PRI_MINIMUM);
}

void HTTP_Done()
{
	//NodeUnRegister((node*)&HTTP);
}

#endif
