/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#include "../common/common.h"
#include "matroska.h"

typedef struct matroska
{
	format_base Format;

} matroska;

static int Probe(matroska* p, const void* Ptr, int Length, const tchar_t* URL )
{
//	const uint8_t* Data = (const uint8_t*)Ptr;
//
//	if (Data[0] == 0xFF && (Data[1] & 0xE0) == 0xE0)
//		return ERR_NONE;

	if (CheckExts(URL,p->Format.Exts))
		return ERR_NONE;

	return ERR_INVALID_DATA;
}

static matroska Matroska;

void Matroska_Init()
{
	Matroska.Format = FormatBase;
	Matroska.Format.Id = MATROSKA_ID;
	Matroska.Format.Exts = T("mkv:V;mka:A");
	Matroska.Format.VMT.Probe = Probe;

	NodeRegister((node*)&Matroska.Format.VMT,PRI_DEFAULT);
}

void Matroska_Done()
{
	NodeUnRegister((node*)&Matroska.Format.VMT);
}