 /***************************************************************************************
 *This program is free software; you can redistribute it and/or modify					*
 * it under the terms of the GNU General Public License as published by					*
 * the Free Software Foundation; either version 2 of the License, or					*
 * (at your option) any later version.													*
 *																						*
 * The GPL can be found at: http://www.gnu.org/copyleft/gpl.html						*
 *																						*
 *																						*	
 ****************************************************************************************
 * Authors:																			  *
 *          Marc Dukette                                                              *
 **************************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif 

#ifndef AVI_INTERFACE_H
#define AVI_INTERFACE_H

/*
 * includes
 */
#include <malloc.h>
#include <stdlib.h>


/*
 * Seek Enum
 */

enum {

	INPUT_SEEK_SET,
	INPUT_SEEK_CUR,
	INPUT_SEEK_END
};

/*
 * Main Class
 */

typedef struct _videoinfo
{
    long               width;             
    long               height;            
    double             fps;               
    char               compressor[8];     
    long               video_frames;      
    char               video_tag[4];      
    long               video_pos;         
     char               audio_tag[4];      
    long               a_fmt;             
    long               a_chans;           
    long               a_rate;            
    long				a_bits;            
    long				audio_bytes;       
	int					threshhold;
	int					AFAP;
	int					ChapterCount;
	TCHAR				ChapterDisplay[100][50];
}videoinfo;



typedef int (CALLBACK* pREADER_Open)(LPTSTR lpFilename, int Cache, int CacheSize,videoinfo** vidinfo);

typedef int (CALLBACK* pREADER_ReadAudio)(char *audbuf, int bytes);

typedef int (CALLBACK* pREADER_NextVideoFrame)(char *buffer, int drop);

typedef BOOL (CALLBACK* pREADER_isKeyFrame)(long frame);

typedef int (CALLBACK* pREADER_Seek)(int percent, int isFrame);

typedef int (CALLBACK* pREADER_SeekChapter)(int chapter);

typedef int (CALLBACK* pREADER_ReSeekAudio)();

typedef double (CALLBACK* pREADER_GetProgress)();

typedef int (CALLBACK* pREADER_Close)();

typedef void (CALLBACK* pREADER_Pause)(int pause);

typedef int (CALLBACK* pREADER_Stop)();

typedef struct _reader
{
	pREADER_Open READER_Open;
	pREADER_ReadAudio READER_ReadAudio;
	pREADER_NextVideoFrame READER_NextVideoFrame;
	pREADER_Seek READER_Seek;
	pREADER_ReSeekAudio READER_ReSeekAudio;
	pREADER_GetProgress READER_GetProgress;
	pREADER_Close READER_Close;
	pREADER_isKeyFrame READER_isKeyFrame;
	pREADER_SeekChapter READER_SeekChapter;
	pREADER_Pause		READER_Pause;
	pREADER_Stop		READER_Stop;
}reader;


#endif
#ifdef __cplusplus
}
#endif 
