/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/
 
#include "../common/common.h"
#include "mpc.h"
#include "mpcdec/mpc_dec.h"

typedef struct mpc
{
	format_base Format;

} mpc;

static int Probe(mpc* p, const void* Ptr, int Length, const tchar_t* URL )
{
	//const uint8_t* Data = (const uint8_t*)Ptr;

	if (CheckExts(URL,p->Format.Exts))
		return ERR_NONE;

	return ERR_INVALID_DATA;
}

static mpc MPC;

void MPC_Init()
{
	MPC.Format = FormatBase;
	MPC.Format.Id = MPC_ID;
	MPC.Format.Exts = T("mpc:A");
	MPC.Format.VMT.Probe = (fmtprobe)Probe;

	NodeRegister((node*)&MPC.Format.VMT,PRI_DEFAULT);
}

void MPC_Done()
{
	NodeUnRegister((node*)&MPC.Format.VMT);
}