/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#ifndef __MPEG_DECODE_H
#define __MPEG_DECODE_H

#define SEQ_END_CODE			0x1B7
#define SEQ_START_CODE			0x1B3
#define GOP_START_CODE			0x1B8
#define PICTURE_START_CODE		0x100
#define SLICE_MIN_START_CODE	0x101
#define SLICE_MAX_START_CODE	0x1Af
#define EXT_START_CODE			0x1B5
#define USER_START_CODE			0x1B2

#define I_VOP					1
#define P_VOP					2
#define B_VOP					3

typedef struct mpeg_decode
{
	node VMT;

	// bitstream
	int bits;
	int bitpos;
	const uint8_t *bitptr;
	const uint8_t *bitend;

	video Format;
	idct* IDCT;
	bool_t LowDelay;
	int BufCount;
	int Total;
	int Dropped;
	int Show;
	int Frame;
	packet Packet;
	
	merge Merge;
	tick_t FrameTime;
	tick_t StartTime;
	int StartPos;
	int StartState;
	bool_t StartFound;

	int mb_xsize;
	int mb_ysize;
	int pos_end;
	int prediction_type;
	int first_slice;
	int dc_lum_scaler;
	int dc_chr_scaler;
	int full_pel[2];
	int f_code[2][2];

	// motion compensation buffer
	int* mv_buf;
	int* _mv_buf;
	int mv_bufmask;

    uint8_t IntraMatrix[64];
    uint8_t ChromaIntraMatrix[64];
    uint8_t InterMatrix[64];
    uint8_t ChromaInterMatrix[64];

} mpeg_decode;

#endif