/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#ifndef __OVERLAY_H
#define __OVERLAY_H

#define AHI_ID		FOURCC('A','H','I','_')
#define AHIIDCT_ID	FOURCC('A','H','I','I')
#define DDRAW_ID	FOURCC('D','R','A','W')
#define DIRECT_ID	FOURCC('D','I','R','C')
#define FLYTV_ID	FOURCC('F','L','Y','T')
#define GAPI_ID		FOURCC('G','A','P','I')
#define GDI_ID		FOURCC('G','D','I','_')
#define RAW_ID		FOURCC('R','A','W','D')

#define AHI_NAME		0x100
#define AHI_VERSION		0x101
#define AHI_REVISION	0x102
#define AHI_CHIPID		0x103
#define AHI_REVISIONID	0x104
#define AHI_TOTALMEMORY	0x105
#define AHI_INTERNALTOTALMEM	0x106
#define AHI_EXTERNALTOTALMEM	0x107
#define AHI_INTERNALFREEMEM		0x10E
#define AHI_EXTERNALFREEMEM		0x10F
#define AHI_CAPS1		0x108
#define AHI_CAPS2		0x109
#define AHI_CAPS3		0x10A
#define AHI_CAPS4		0x10B
#define AHI_IDCTBUG		0x110
#define AHI_DEVICEBITMAP 0x111
#define AHI_LANDINTERNAL 0x112

#define AHI_OUT_OF_MEMORY 0x200
#define AHI_OPEN_IDCT	 0x201
#define AHI_OLDVERSION	 0x202

#define GAPI_WIDTH		0x100
#define GAPI_HEIGHT		0x101
#define GAPI_PITCHX		0x102
#define GAPI_PITCHY		0x103
#define GAPI_BPP		0x104
#define GAPI_FORMAT		0x105

#define RAW_WIDTH		0x100
#define RAW_HEIGHT		0x101
#define RAW_PITCHX		0x102
#define RAW_PITCHY		0x103
#define RAW_BPP			0x104
#define RAW_FORMAT		0x105
#define RAW_POINTER		0x106

#define GAPI_OPEN_ERROR	0x200

extern void AHI_Init();
extern void AHI_Done();
extern void DDraw_Init();
extern void DDraw_Done();
extern void Direct_Init();
extern void Direct_Done();
extern void FlyTV_Init();
extern void FlyTV_Done();
extern void GAPI_Init();
extern void GAPI_Done();
extern void GDI_Init();
extern void GDI_Done();
extern void RAW_Init();
extern void RAW_Done();

#endif