/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#include "stdafx.h"

static tchar_t PROGRAM_TITLE[] = T("BetaPlayer");
static tchar_t PROGRAM_VERSION[] = T("0.04");

BOOL CALLBACK EnumWindowsProc(HWND Wnd,LPARAM Param)
{
	HWND* p = (HWND*)Param;
	if (GetWindow(Wnd,GW_OWNER) == *p)
	{
		*p = Wnd;
		return 0;
	}
	return 1;
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hParent,TCHAR* Cmd,int CmdShow)
{
	HWND Wnd;

	Node_Init(PROGRAM_TITLE,PROGRAM_VERSION,WinMain,Cmd);

	Wnd = FindWindow(WinClassName(), NULL);
	if (Wnd)
	{
		if (NodeCmdLine()[0])
		{
			NodeSaveValue(IF_REG_OPEN,NodeCmdLine(),(tcslen(NodeCmdLine())+1)*sizeof(tchar_t),TYPE_STRING);
			SendMessage(Wnd,MSG_OPEN,0,0);
		}

		while (!IsWindowEnabled(Wnd))
		{
			HWND Last = Wnd;
			EnumWindows(EnumWindowsProc,(LPARAM)&Wnd);
			if (Wnd == Last)
				break;
		}
		SetForegroundWindow(Wnd);
		return 0;
	}

	SAFE_BEGIN

	NodePlugins();
	Player_Init();
	Win_Init(hInstance,IDI_ICON);
	MediaInfo_Init();
	BenchResult_Init();
	About_Init();
	QueryKey_Init();
	Settings_Init();
	OpenFile_Init();
	Association_Init();
	Interface_Init();
	PlayList_Init();
	PLS_Init();
	M3U_Init();

	// user input needs priority
	SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);

	WinOpen((win*)NodeFind(INTERFACE_ID),NULL,0);

	M3U_Done();
	PLS_Done();
	PlayList_Done();
	Interface_Done();
	Association_Done();
	OpenFile_Done();
	Settings_Done();
	QueryKey_Done();
	About_Done();
	BenchResult_Done();
	MediaInfo_Done();
	Win_Done();
	Player_Done();
	Node_Done();

	SAFE_END
	return 0;
}

