/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#include "stdafx.h"

typedef struct querykey
{
	win Win;
	int Key;
	int Key2;

} querykey;

static bool_t DialogProc(querykey* p,int Msg, WPARAM wParam, LPARAM lParam, int* Result)
{
	switch (Msg)
	{
	case WM_SYSKEYDOWN:
	case WM_KEYDOWN:

		if (wParam != VK_CONTROL && wParam != VK_MENU && 
			wParam != VK_LWIN && wParam != VK_RWIN && wParam != VK_SHIFT)
		{
			int Key;

			if (QueryPlatform(PLATFORM_TYPENO)==TYPE_SMARTPHONE &&
				(wParam == VK_F1 || wParam == VK_F2))
					break; // can't loose menu

			Key = wParam;
			if (GetKeyState(VK_CONTROL)<0) Key |= HOTKEY_CTRL;
			if (GetKeyState(VK_SHIFT)<0) Key |= HOTKEY_SHIFT;
			if (GetKeyState(VK_MENU)<0) Key |= HOTKEY_ALT;
			if (GetKeyState(VK_LWIN)<0 || GetKeyState(VK_RWIN)<0) Key |= HOTKEY_WIN;
			
			if (Key >= 0xC1 && Key <= 0xCF)	Key |= HOTKEY_WIN; // h3800 ???

			p->Key2 = Key;
			if (!p->Key) 
				p->Key = Key;
		}
		break;

	case WM_SYSKEYUP:
	case WM_KEYUP:
		PostMessage(p->Win.Wnd,WM_CLOSE,0,0);
		break;

	case WM_KILLFOCUS:
		WinAllKeys(0);
		break;

	case WM_SETFOCUS:
		WinAllKeys(1);
		break;
	}
	return 0;
}

static bool_t Proc(querykey* p,int Msg, WPARAM wParam, LPARAM lParam, int* Result)
{
	switch (Msg)
	{
	case WM_ACTIVATE:
		if (LOWORD(wParam)==WA_INACTIVE) 
			PostMessage(p->Win.Wnd,WM_CLOSE,0,0);
		break;

	case WM_COMMAND:
		if (LOWORD(wParam) == PLATFORM_OK)
			PostMessage(p->Win.Wnd,WM_CLOSE,0,0);
		break;

	case WM_CREATE:
		p->Key = 0;
		p->Key2 = 0;
		WinCreateDialog(&p->Win);
		WinLabel(&p->Win,(p->Win.DlgHeight-12) >> 1,0,p->Win.DlgWidth,String(QUERYKEY_ID,QUERYKEY_MSG),
			12,LABEL_CENTER,NULL);
		break;
	}
	return 0;
}

static int Get(querykey* p,int No,void* Data,int Size)
{
	int Result = ERR_INVALID_PARAM;
	switch (No)
	{
	case QUERYKEY_KEY: GETVALUE(p->Key,int); break;
	case QUERYKEY_KEY2: GETVALUE(p->Key2,int); break;
	}
	return Result;
}

static querykey QueryKey;

void QueryKey_Init()
{
	memset(&QueryKey,0,sizeof(QueryKey));
	QueryKey.Win.Id = QUERYKEY_ID;
	QueryKey.Win.Width = 200;
	QueryKey.Win.Height = 200;
	QueryKey.Win.Dialog = 1;
	QueryKey.Win.Title = String(QUERYKEY_ID,QUERYKEY_TITLE);
	QueryKey.Win.Proc = Proc;
	QueryKey.Win.DialogProc = DialogProc;
	QueryKey.Win.Get = Get;
	WinRegister(&QueryKey.Win,PRI_DEFAULT);
}

void QueryKey_Done()
{
	WinUnRegister(&QueryKey.Win);
}