/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#include "..\common\common.h"
#include <windows.h>

DLLEXPORT int WINAPI Install_Init( HWND Parent, BOOL FirstCall, BOOL PrevInstalled, LPCTSTR InstallDir )
{
    return 0;
}

DLLEXPORT int WINAPI Install_Exit( HWND Parent, LPCTSTR InstallDir, WORD FailedDirs,WORD FailedFiles,WORD FailedRegKeys,WORD FailedRegVals,WORD FailedShortcuts )
{
	HMODULE GAPI;
	HMODULE CoreDLL;
	TCHAR LocalPath[MAXPATH];
	TCHAR WinPath[MAXPATH];

#ifdef ARM
	tchar_t* Base = T("System\\GDI\\Drivers\\ATI");
	tchar_t* Name = T("DisableDeviceBitmap");

	DWORD Disp;
	DWORD RegType;
	DWORD RegSize;
	DWORD Value;
	HKEY Key;
	HANDLE Handle = LoadLibrary(T("ACE_DDI.DLL"));

	if (Handle)
	{
		FreeLibrary(Handle);

		if (RegCreateKeyEx( HKEY_LOCAL_MACHINE, Base, 0, NULL, 0, 0, NULL, &Key, &Disp ) == ERROR_SUCCESS)
		{
			RegSize=sizeof(Value);
			if (RegQueryValueEx( Key, Name, 0, &RegType, (LPBYTE)&Value, &RegSize ) != ERROR_SUCCESS || !Value)
			{
				Value = 1;
				RegSetValueEx( Key, Name, 0, REG_DWORD, (LPBYTE)&Value, sizeof(Value) );

				MessageBox(Parent,
					T("ATI IMAGEON device bitmap caching disabled. ") 
					T("Please warm boot the device for changes to take effect! ")
					T("You can change this setting later in the player too."),T("Setup"),MB_OK);
			}
			RegCloseKey( Key );
		}
	}
#endif

	tcscpy(WinPath,T("\\Windows"));

	CoreDLL = LoadLibrary(T("coredll.dll"));
	if (CoreDLL)
	{
		BOOL (WINAPI* FuncSHGetSpecialFolderPath)(HWND,LPTSTR,int,BOOL);

		*(FARPROC*)&FuncSHGetSpecialFolderPath = GetProcAddress(CoreDLL,T("SHGetSpecialFolderPath"));

		if (FuncSHGetSpecialFolderPath)
			FuncSHGetSpecialFolderPath(NULL,WinPath,0x24/*CSIDL_WINDOWS*/,FALSE);

		FreeLibrary(CoreDLL);
	}

	tcscat(WinPath,T("\\gx.dll"));
	tcscpy(LocalPath,InstallDir);
	tcscat(LocalPath,T("\\gx.dll"));

	GAPI = LoadLibrary(WinPath);
	if (GAPI)
	{
		FreeLibrary(GAPI);
		DeleteFile(LocalPath);
	}
	else
	{
		GAPI = LoadLibrary(LocalPath); // can we load our gx.dll? aygshell.dll available?
		if (GAPI)
			FreeLibrary(GAPI);
		else
			DeleteFile(LocalPath);
	}

	return 0;
}

DLLEXPORT int WINAPI Uninstall_Init(HWND Parent, LPCTSTR InstallDir)
{
    return 0;
}

DLLEXPORT int WINAPI Uninstall_Exit(HWND hwndParent)
{
 	RegDeleteKey( HKEY_LOCAL_MACHINE, T("SOFTWARE\\BetaPlayer"));
	return 0;
}
